/**
 * MyAppletWriteFile.java
 *
 * Created on March 29, 2001, 12:20 PM
 */

/**
 *
 * @author  Michael Thomas, thomasma@us.ibm.com
 * @version 1.0
 */

/**
  * This applet will throw a SecurityException unless you create a policy
  * for:
  * Use policytool.exe in the JDK 1.2 or 1.3 bin directory
  * Policy:
  *   Codebase example:  file:/d:/java   (for Browsers notice one "/" after file:)
  *   Signed By:  <leave empty>
  * Permissions:
  *   FilePermission
  *   Target Name: MyAppletWriteFile.txt
  *   Actions: read,write
  */


import java.awt.*;
import java.io.*;
import java.net.*; 
import java.lang.*;
import java.applet.*;
//CLASSPATH=c:\Program Files\Netscape\Communicator\Program\java\classes\java40.jar;
//CLASSPATH=c:\Program Files\Netscape\Communicator\Program\Java\Classes\java40.jar
//import com.ms.wfc.app.*;   

/**
 Notes:
 import netscape.security.*; //Needed for PrivilegeManager.class & Target.class
 import com.ms.security.*;   //Needed for PolicyEngine.class & PermissionID.class
*/

public class MyAppletWriteFile extends Applet {

    boolean blnDebugOn = false;

    String strFileOut = "MyAppletWriteFile.txt"; //Default
    String strFileIn  = "MyAppletWriteFile.txt"; //Default
    String strPathName = "c:/temp/";  //Default
    String strFileName = "";
    String strMsg = "Default msg: Hello World from my Applet v1.0"; //Default message.
    
    String strParmDebug, strParmDebugProperties, strParmDebugMsg;
    String strParmFileName, strParmPathName;
    
    String strBrowserName, strBrowserType;
    boolean blnSecuritySupported = false;
    
//------------------------------------------------------------------------------------
  public void init() {
//------------------------------------------------------------------------------------
    
    System.out.println( "Before call to System.getProperty(\"java.vendor\")");
    strBrowserName = System.getProperty("java.vendor");
      
    if (strBrowserName.indexOf("Netscape") > -1) {
      strBrowserType = "Netscape";
      blnSecuritySupported = true;
    } else if ( strBrowserName.indexOf("Microsoft") > -1 ) {
      strBrowserType = "IE";
      blnSecuritySupported = true;
    } else if ( strBrowserName.indexOf("Apple") > -1 ) {
      strBrowserType = "MAC IE";
      blnSecuritySupported = false;
    } else if ( strBrowserName.indexOf("Sun") > -1 ) {
      strBrowserType = "Sun"; //IE's Java Plugin
      blnSecuritySupported = false;
    } else {
      strBrowserType = "Other - need to fix Java Code"; 
      blnSecuritySupported = false;
    }

    System.out.println( "Browser Name = " + strBrowserName);
    System.out.println( "Browser Type = " + strBrowserType);    
    
    this.strParmDebug = getParameter("debug");
    
    this.strParmDebugMsg = getParameter("debugmsg");    
    this.strParmDebugProperties = getParameter("debugproperties");   
    this.strParmFileName = getParameter("filename");  
    this.strParmPathName = getParameter("pathname");           
    
    String osname = System.getProperty("os.name");
    
    if ( this.strParmDebug != null ) {
      this.blnDebugOn = ( strParmDebug.toLowerCase().equals("true") ? true : false );      
    }
    
    if ( this.strParmFileName != null ) {
      this.strFileOut  = this.strParmFileName;
      this.strFileIn   = this.strParmFileName;
    }
    
    if ( this.strParmPathName != null ) {
      this.strPathName = this.strParmPathName;
    }    
    
    if ( strParmDebugMsg != null ) { 
      this.strMsg = strParmDebugMsg;
    }

    if ( strParmDebugProperties != null && strParmDebugProperties.toLowerCase().equals("true") ) {     
      getDebugProperties();
    }
    
    if ( blnDebugOn ) { 
      System.out.println ( "debugging = " + strParmDebug );      
    }

    String strNetscapeFlashHangFix = appletReadFile();  //Have to request right permission or 
                                                        //Netscape will hang with Flash!
   
  }
//------------------------------------------------------------------------------------  
  public String debugTesting ( ) {
//------------------------------------------------------------------------------------
    System.out.println("In debugTestin().");
    String strData = "Default Hello from debugTesting()";
    return( strData ); 
  }
//------------------------------------------------------------------------------------  
  public String debugTesting ( String strData ) {
//------------------------------------------------------------------------------------
     System.out.println("In debugTestin( String ).");
     return( strData ); 
  }
//------------------------------------------------------------------------------------
  public void appletWriteFile( String strData ) {
//------------------------------------------------------------------------------------

    if ( this.blnDebugOn ) System.out.println ("Preparing to get Browsers permissions." );
    
  	try {

      if (blnSecuritySupported) {

        if(strBrowserType == "Netscape") { 

          if (Class.forName("netscape.security.PrivilegeManager") != null) {
            System.out.println( "In appletWriteFile: Before asking for Netscape's UniversalFileAccess. ");
            netscape.security.PrivilegeManager.enablePrivilege("UniversalFileAccess");
            System.out.println( "In appletWriteFile: After asking for Netscape's UniversalFileAccess. ");
          }

        } else if (strBrowserType == "IE") { 
          
          if (Class.forName("com.ms.security.PolicyEngine") != null) {
            System.out.println( "In appletWriteFile: Before asking for IE's FileIOPermission. ");                      
         		com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.FILEIO);
         		com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.USERFILEIO);
            com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.SYSTEM);
            com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.NETIO);  
            System.out.println( "In appletWriteFile: After asking for IE's FileIOPermission. ");
          }
        } 
        
      }

      strFileName = strPathName + strFileOut;

      if ( this.blnDebugOn ) System.out.println ("Preparing to attempt file I/O (write): " + strFileName );      
    
      System.out.println( "In appletWriteFile: Before create FileWriter.");
      FileWriter fwFileOut      = new FileWriter (strFileName);
      System.out.println( "In appletWriteFile: Before create BufferedWriter.");      
      BufferedWriter bwFileOut  = new BufferedWriter (fwFileOut);
      System.out.println( "In appletWriteFile: Before create PrintWriter.");            
      PrintWriter pwFileOut     = new PrintWriter (bwFileOut);
      
      System.out.println( "In appletWriteFile: Before actual write to local file.");                          
      pwFileOut.println ( strData );
      pwFileOut.close();
    
      if ( this.blnDebugOn ) System.out.println ("Successfully wrote to the file named " + strFileName + " -- go take a look at it!");
         
  	} catch (ClassNotFoundException e) {
	    System.out.println("appletWriteFile: Could not find a class." );
      e.printStackTrace();                      
    } catch (SecurityException e) {
	    System.out.println("appletWriteFile: Caught security exception with file: " + strFileName );
      e.printStackTrace();                      
    } catch (IOException e) {
		   System.out.println("appletWriteFile: Caught i/o exception");
       e.printStackTrace();                
    }  catch (Exception e) {
		   System.out.println("appletWriteFile: Exeception caught - See Java Console for details.");
       e.printStackTrace();                
    }
    
  }
//------------------------------------------------------------------------------------    
  public String appletReadFile() {
//------------------------------------------------------------------------------------
    String strReturn = "";
    String strLine = "";

    if ( this.blnDebugOn ) System.out.println ("Preparing to attempt file I/O (read): " + strFileName );

    try {

      if (blnSecuritySupported) {

        if(strBrowserType == "Netscape") { 

          if (Class.forName("netscape.security.PrivilegeManager") != null) {
            System.out.println( "In appletReadFile: Before asking for Netscape's UniversalFileAccess. ");        
            netscape.security.PrivilegeManager.enablePrivilege("UniversalFileAccess");
            System.out.println( "In appletReadFile: After asking for Netscape's UniversalFileAccess. ");        
          }

        } else if (strBrowserType == "IE") { 
          if (Class.forName("com.ms.security.PolicyEngine") != null) {
            System.out.println( "In appletReadFile: Before asking for IE's FileIOPermission.. ");        
         	  com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.FILEIO);
            com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.USERFILEIO);
            //com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.SYSTEM);
            //com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.NETIO);  
            System.out.println( "In appletReadFile: Before asking for IE's FileIOPermission.. ");        
          }
        } 
        
      }

      strFileName = strPathName + strFileIn;
      
      FileReader frFileIn        = new FileReader (strFileName);
      BufferedReader brFileIn    = new BufferedReader (frFileIn);
    
      strLine   = brFileIn.readLine(); 
     
       while ( strLine != null )
       {
         strReturn += strLine;
         strLine = brFileIn.readLine();
       } 
         
       brFileIn.close();

       if ( this.blnDebugOn ) System.out.println("Successfully read from the file named " + strFileName + " -- go take a look at it!");
       if ( this.blnDebugOn ) System.out.println(strReturn);
       
    } catch (ClassNotFoundException e) {
	    System.out.println("appletReadFile: Could not find a class." );
      e.printStackTrace();                      
	  } catch (SecurityException e) {
	    System.out.println("appletReadFile: Caught security exception with file: " + strFileName);
      System.out.println( e.toString());
    } catch (IOException ioe) {
		  System.out.println("appletReadFile: File did not exist.  This could be OK!!!");
    } catch (Exception e) {
		   System.out.println("appletReadFile: Exeception caught - See Java Console for details.");
       e.printStackTrace();                
    } finally {
      return strReturn; 
    }
    
  }
//------------------------------------------------------------------------------------  
  public void getDebugProperties() {
//------------------------------------------------------------------------------------    
    String s;

    try {

      if (blnSecuritySupported) {

        if(strBrowserType == "Netscape") { 

          if (Class.forName("netscape.security.PrivilegeManager") != null) {
           System.out.println( "Before asking Netscape for UniversalPropertyRead. ");        
           netscape.security.PrivilegeManager.enablePrivilege("UniversalPropertyRead");
           System.out.println( "After asking Netscape for UniversalPropertyRead. ");        
          }

        } else if (strBrowserType == "IE") { 
          
          if (Class.forName("com.ms.security.PolicyEngine") != null) {
            System.out.println( "getDebugProperties(): Before asking for IE's SYSTEM permission. ");                      
         		//com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.FILEIO);
         		//com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.USERFILEIO);
            com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.SYSTEM);
            //com.ms.security.PolicyEngine.assertPermission(com.ms.security.PermissionID.NETIO);  
            System.out.println( "getDebugProperties(): After asking for IE's SYSTEM permission. ");                      
          }

        } 
        

      }
      
      //To make this run in an applet you need to setup security permissions for each
      //  property!  Use polictool.exe for JDK1.2 or JDK1.3.

      System.out.println( "Browser Name = " + strBrowserName);
      System.out.println( "Browser Type = " + strBrowserType);          
      
      System.out.println("About to get os.name property value");
      s = System.getProperty("os.name", "not specified");
      System.out.println("  The name of your operating system is: " + s);

      System.out.println("About to get java.version property value");
      s = System.getProperty("java.version", "not specified");
      System.out.println("  The version of the JVM you are running is: " + s);

      System.out.println("About to get user.home property value");
      s = System.getProperty("user.home", "not specified");
      System.out.println("  Your user home directory is: " + s);

      System.out.println("About to get java.home property value");
      s = System.getProperty("java.home", "not specified");
      System.out.println("  Your JRE installation directory is: " + s);

    } catch (ClassNotFoundException e) {
	    System.out.println("getDebugProperties(): Could not find a class." );
      e.printStackTrace();                      
    } catch (Exception e) {
		  System.out.println("getDebugProperties(): Exeception caught - See Java Console for details.");
      e.printStackTrace();                
    }

  }
//------------------------------------------------------------------------------------  
  public void paint(Graphics g) {
//------------------------------------------------------------------------------------
    
  }    
  
} //End of class

